import { APIGatewayProxyEvent, APIGatewayProxyResult } from 'aws-lambda';
import { RestApiRouteHandler, RestPathParams, RestQueryParams, RestRequestBody, RestRequestHeaders, RestRequireAuthentication, RestResponseBody } from '../types';
export type AnyRestApiRouteHandler = RestApiRouteHandler<RestPathParams, RestQueryParams, RestRequestHeaders, RestRequestBody, RestResponseBody, RestRequireAuthentication>;
export declare class RestApi {
    private routeHandlers;
    addRouteHandler<PathParams extends RestPathParams, QueryParams extends RestQueryParams, RequestHeaders extends RestRequestHeaders, RequestBody extends RestRequestBody, ResponseBody extends RestResponseBody, RequireAuthentication extends RestRequireAuthentication>(routeHandler: RestApiRouteHandler<PathParams, QueryParams, RequestHeaders, RequestBody, ResponseBody, RequireAuthentication>): this;
    handleRequest(proxyEvent: APIGatewayProxyEvent, onError?: (error: unknown) => Promise<void>): Promise<APIGatewayProxyResult>;
    private getMatchingRouteHandlers;
    private getMatchingRouteHandler;
    private extractPathParams;
    private extractQueryParams;
}
//# sourceMappingURL=RestApi.d.ts.map